unit TCPMMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls, OleCtrls, isp3;

type
  TFormTCP = class(TForm)
    TCPClient: TClientSocket;
    cbxServer: TComboBox;
    butConnect: TButton;
    cbxPort: TComboBox;
    rabInput: TRadioButton;
    butSend: TButton;
    edtInput: TMemo;
    edtSend: TMemo;
    procedure FormResize(Sender: TObject);
    procedure butConnectClick(Sender: TObject);
    procedure TCPClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure TCPClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure TCPClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure TCPClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure butSendClick(Sender: TObject);
  private
   TheSocket: TCustomWinSocket;
   Function Clip(S:String):String;
  public
  end;

var
  FormTCP: TFormTCP;

implementation

{$R *.DFM}

procedure TFormTCP.FormResize(Sender: TObject);
begin
 edtInput.Width:=ClientWidth-edtInput.Left*2+rabInput.Width;
end;

procedure TFormTCP.butConnectClick(Sender: TObject);
begin
 if TCPClient.Active then
  begin TCPClient.Active:=False; end
 else
  begin
   TCPClient.Host:=cbxServer.Text;
   TCPClient.Port:=StrToInt(cbxPort.Text);
   TCPClient.Active:=True;
   butConnect.Caption:='&Disconnect';
  end;
end;

procedure TFormTCP.TCPClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 butConnect.Caption:='&Connect';
 butSend.Enabled:=True; edtSend.Enabled:=True;
 Caption:='Disconnected from '+Socket.RemoteAddress+':'+IntToStr(Socket.RemotePort);
end;

procedure TFormTCP.TCPClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 butConnect.Caption:='&Disconnect';
 butSend.Enabled:=True; edtSend.Enabled:=True; TheSocket:=Socket;
 Caption:='Connected to '+Socket.RemoteAddress+':'+IntToStr(Socket.RemotePort);
end;

procedure TFormTCP.TCPClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
 butConnect.Caption:='&Connect';
end;

Function TFormTCP.Clip(S:String):String;
Var I:Integer; T:String;
begin
 Result:='';
 For I:=1 to Length(S) do if S[I]<#30 then
  begin
   if Result<>'' then edtInput.Text:=Result;
   Result:='';
  end else Result:=Result+S[I];
 if Result<>'' then edtInput.Text:=Result;
end;

procedure TFormTCP.TCPClientRead(Sender: TObject; Socket: TCustomWinSocket);
begin
 rabInput.Checked:=True;
 {Clip(Socket.ReceiveText);}
 edtInput.Text:=Socket.ReceiveText;
 rabInput.Checked:=False;
end;

procedure TFormTCP.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 TCPClient.Active:=False;
end;

procedure TFormTCP.FormShow(Sender: TObject);
begin
 Caption:='TCP Client';{+TCPClient.Address;} {Socket.LocalAddress;}
end;

procedure TFormTCP.butSendClick(Sender: TObject);
Var S:ANSIString;
begin
 S:=edtSend.Text{+#10#13};
 TCPClient.Socket.SendText(S);
end;

end.
